#include <avr/io.h>
#include "lcd-routines.h"
#include <util/delay.h>


void lcd_data(unsigned char temp1)
{
	unsigned char temp2=temp1;

	LCD_PORT |=(1<<LCD_RS);

	temp1=temp1 >>4;
	temp1=temp1 & 0x0F;
	LCD_PORT &=0xF0;
	LCD_PORT |=temp1;
	lcd_enable();

	temp2=temp2 & 0x0F;
	LCD_PORT &=0xF0;
	LCD_PORT |=temp2;

	lcd_enable();
	_delay_us(42);
}

void lcd_command(unsigned char temp1)
{
	unsigned char temp2=temp1;
	LCD_PORT &= ~(1<<LCD_RS);
	
	temp1=temp1 >>4;
	temp1=temp1 & 0x0F;
	LCD_PORT &=0x0F;
	LCD_PORT |=temp1;
	lcd_enable();

	temp2=temp2 & 0x0F;
	LCD_PORT &= 0xF0;
	LCD_PORT |=temp2;
	lcd_enable();

	_delay_us(42);
}

void lcd_enable(void)
{
	LCD_PORT |=(1<<LCD_EN);
	_delay_us(1);
	LCD_PORT &= ~(1<<LCD_EN);
}

void lcd_init(void)
{
	LCD_DDR=LCD_DDR |0x0F |(1<<LCD_RS) |(1<<LCD_EN);
	_delay_ms(15);
	LCD_PORT &=0xF0;
	LCD_PORT |= 0x03;
	LCD_PORT &= ~(1<<LCD_RS);
	lcd_enable();
	_delay_ms(5);
	lcd_enable();	
	_delay_ms(1);
	lcd_enable();
	_delay_ms(1);

	LCD_PORT &= 0xF0;
	LCD_PORT |=0x02;
	lcd_enable();

	lcd_command(0x28);
	lcd_command(0x0C);
	lcd_command(0x06);
	lcd_clear();
}

void lcd_clear(void)
{
	lcd_command(CLEAR_DISPLAY);
	_delay_ms(5);
}

void lcd_home(void)
{
	lcd_command(CURSOR_HOME);
	_delay_ms(5);
}

void set_cursor(uint8_t x,uint8_t y)
{
	uint8_t tmp;
	
	switch(y)
	{
		case 1: tmp=0x80+0x00+x; break;
		case 2: tmp=0x80+0x40+x; break;
		case 3: tmp=0x80+0x10+x; break;
		case 4: tmp=0x80+0x50+x; break;
	}
	lcd_command(tmp);
}

void lcd_string(char *data)
{
	while(*data)
	{
		lcd_data(*data);
		data++;
	}
}
		





















































